﻿<#
╔══════════════════════════════════════════════════════════════════════════════╗
║                                                                              ║		  
║                               Building Methods                               ║
╟──────────────────────────────────────────────────────────────────────────────╢
║	                       Interface Technical Training                        ║
║	                             Jason A Yoder                                 ║
║	                                                                           ║
╚══════════════════════════════════════════════════════════════════════════════╝
#>

# Open an instance of Notepad.
Notepad

# Get the process that represents the instance of Notepad
Get-Process -Name Notepad

# Display the methods of the process object.
Get-Process -Name Notepad | Get-Member -MemberType Methods

# Discover the documentation for System.Diagnostics.Process
Start-Process -FilePath "https://msdn.microsoft.com/en-us/library/system.diagnostics.process(v=vs.110).aspx"


# Execute the kill method.
(Get-Process -Name Notepad).Kill()


# Out basic cmdlet.
Function Test-Method1 {
Param ($Value)

    # Create an object.
    $Obj = New-Object -TypeName PSObject -Property @{
        'Value' = $Value
    }

    # Place the object in the PowerShell Pipeline.
    Write-Output $Obj
}

# Test the cmdlet
Test-Method1 -Value 10

# Verify that it is an  object.
Test-Method1 -Value 10 | Get-Member

# Add a method that does not accept an argument.
Function Test-Method1 {
Param ($Value)

    # Create an object.
    $Obj = New-Object -TypeName PSObject -Property @{
        'Value' = $Value
        }

    # Create a method that does not accept an argument.
    $Obj | Add-Member -MemberType ScriptMethod `
                      -Name ClearValue `
                      -Value {$This.Value = 0}

    # Place the object in the PowerShell Pipeline.
    Write-Output $Obj
}

# Test the cmdlet
Test-Method1 -Value 10

# Verify that it is an  object.
Test-Method1 -Value 10 | Get-Member

# Place the object in a variable.
$Data = Test-Method1 -Value 10

# Verify its contents
$Data

# Call the method.
$Data.ClearValue()

# Verify its contents
$Data


# Add a method that accepts an argument.
Function Test-Method1 {
Param ($Value)

    # Create an object.
    $Obj = New-Object -TypeName PSObject -Property @{
        'Value' = $Value
        }

    # Create a method that does not accept an argument.
    $Obj | Add-Member -MemberType ScriptMethod `
                      -Name ClearValue `
                      -Value {$This.Value = 0}

    # Create a method that accepts an argument.
    $Obj | Add-Member -MemberType ScriptMethod `
                      -Name AddNumber `
                      -Value {
                        Param ($Number)
                        $This.Value = $This.Value + $Number
                        }

    # Place the object in the PowerShell Pipeline.
    Write-Output $Obj
}

# Test the cmdlet
Test-Method1 -Value 10

# Verify that it is an  object.
Test-Method1 -Value 10 | Get-Member

# Place the object in a variable.
$Data = Test-Method1 -Value 10

# Verify its contents
$Data

# Call the method.
$Data.AddNumber(5)

# Verify its contents
$Data